import array

def is_valid(target):
    return type(target) == array.array or target.typecode != 'i'

def swap(target, a, b):
    buffer = target[a]
    target[a] = target[b]
    target[b] = buffer

def bubble_sort(target):
    if is_valid(target):
        swapped = True
        while swapped:
            swapped = False
            for i in range(0, len(target) - 1):
                if target[i] > target[i + 1]:
                    swap(target, i, i + 1)
                    swapped = True

def quick_sort(target, first=0, last=None):
    if is_valid(target):
        if last is None:
            last = len(target) - 1
        if first < last:
            split_point = partition(target, first, last)
            quick_sort(target, first, split_point - 1)
            quick_sort(target, split_point + 1, last)

def partition(target, first, last):
    pivot_value = target[first]
    left_mark = first + 1
    right_mark = last
    done = False
    while not done:
        while left_mark <= right_mark and target[left_mark] <= pivot_value:
            left_mark += 1
        while target[right_mark] >= pivot_value and right_mark >= left_mark:
            right_mark -= 1
        if right_mark < left_mark:
            done = True
        else:
            swap(target, left_mark, right_mark)
    swap(target, first, right_mark)
    return right_mark

my_array = array.array('i', [9, 5, 4, 7, 6, 8, 1, 3, 2])
bubble_sort(my_array)
print(my_array)

my_array = array.array('i', [9, 5, 4, 7, 6, 8, 1, 3, 2])
quick_sort(my_array)
print(my_array)
